:
#######################################################################
## Author: Boris Bellorini                                           ##
## Email: boris.bellorini@trivadis.com                               ##
## Copyright (C) 2002 by Trivadis AG. All rights reserved.           ##
## $Date: 2002/02/19 13:58:19 $                                      ##
## $Revision: 1.6 $                                                  ##
## $Id: L2.4RWdisableX.sh,v 1.6 2002/02/19 13:58:19 bob Exp $        ##
## Abstract: Titan module for disabling listening on X11 TCP 6000    ##
#######################################################################
## The author disclaims all responsibility or liability with respect ##
## to its usage or its effect upon hardware or computer systems.     ##
## Software is provided as it is. Any comment or corrections are     ##
## well appreciated.                                                 ##
#######################################################################

TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
umask 022
DATE=`date +%m%d%y%H%M`
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

preferred=gdm # Set default value Gnome Desktop Manager
if [ -f /etc/sysconfig/desktop ]; then
        source /etc/sysconfig/desktop >/dev/null 2>&1
        [ -n "$DISPLAYMANAGER" ] && DESKTOP=$DISPLAYMANAGER
        if [ "$DESKTOP" = GNOME ]; then
                preferred=gdm
        elif [ "$DESKTOP" = "KDE" -o "$DESKTOP" = "KDE1" -o "$DESKTOP" = "KDE2" ]; then
                preferred=kdm
        elif [ "$DESKTOP" = AnotherLevel ] ; then
                preferred=xdm
        fi
fi

case $preferred in
  gdm)
  SAVEFILES='/etc/X11/gdm/gdm.conf'
  ;;
  xdm)
  SAVEFILES='/etc/X11/xdm/Xservers'
  ;;
  kde)
  #SAVEFILES=''#I don't know for the moment !
  ;;
  *)
  SAVEFILES='/etc/X11/gdm/gdm.conf'
;;
esac

Intro() {
cat << EOF_INTRO

This program check that the X server is running with the -nolisten tcp option.
If set the X server is no more listening on port TCP 6000 and user can no more 
connect remotely to the X server, but just locally

EOF_INTRO
}

Check() {

  run=`netstat -anl|grep 6000|grep -c "" `
  if [ $run -gt 0 ]; then
    echo ""
    echo "X server is listening on socker 6000 - FAILS CHECK"
    echo ""
  else
    echo ""
    echo "X server is not listening on socker 6000 - PASSES CHECK"
    echo ""

  fi

}

Fix() {
  cp $SAVEFILES $SAVEFILES.ORIG.${DATE}
  case $preferred in
  gdm)
  cat $SAVEFILES |sed 's/^0=\/usr\/bin\/X11\/X$/0=\/usr\/bin\/X11\/X -nolisten tcp/'> $SAVEFILES
  ;;
  xdm)
  #cat $SAVEFILES |sed 's/^:0 local \/usr\/X11R6\/bin\/X$/:0 local \/usr\/X11R6\/bin\/X -nolisten tcp/'> $SAVEFILES
  ;;
  kde)
  ;;
  *)
  echo "Don't know how to fix"
  ;;
  esac
  echo "X 11 -nolisten tcp fixed"
  echo "Will take place only after restarting of the X server"
}


 
action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        echo "        ERROR:Invalid arg $action"
        echo "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        echo " "
;;
esac
