#!/bin/sh
# :
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {
cat << EOF

 This program creates a default /etc/issue file so that upon system
 login, users will be displayed a Warning Banner. This banner is contained
 in the file "lib/issue", and should be customized by the local System 
 Administration Staff after consulting with the organization's legal staff.
EOF

}

ShowIssue() {
 t_echo 2 "        Status of /etc/issue - PASSES CHECK"
 t_echo 2 "        Contents of /etc/issue: "
 t_echo 2 " "
	/bin/cat /etc/issue
 t_echo 2 " "
}

FixIssue() {

if [ -f /etc/issue ]; then
 ShowIssue
else
 t_echo 0 "        Building /etc/issue... "
if [ -f ./lib/issue ]; then
/bin/cat ./lib/issue >/etc/issue
else
/bin/cat issue > /etc/issue
fi

if [ -f /etc/issue ]; then   
 t_echo 2 ""
 t_echo 2 "        File /etc/issue created"
 t_echo 2 "        Contents of /etc/issue: "
 t_echo 2 " "
	/bin/cat /etc/issue
 t_echo 2 ""
fi 
fi
}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	FixIssue
	;;
	-[Vv]*)
	if [ -f /etc/issue ]; then
	   ShowIssue
	else
           t_echo 0 "        Cannot read /etc/issue - FAILS CHECK"
	   exit 1
	fi
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac


# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/issue'
