#!/bin/sh
# :
#
# version 3.1.2 bpowell Tue May 25 15:48:36 PDT 1999 
# version 3.2.1 bpowell Fri Oct  1 12:37:12 PDT 1999 backticks in banner line 
# instead of apostrphes

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case "`uname`" in
[Ll]inux)
        t_echo 1 "Hardening ftp services"
;;
*)
        t_echo 1 "This feature is Only supported on Linux OS - ERROR"
        exit 1;;
esac


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


Intro() {

cat << EOF

 
Changes or creates /etc/ftpaccess file to add in a umask,  ftp banner
and restrictions on file transfers. If you are unlucky enough to lose
your root password this change will restrict downloads of any files named
passwd or shadow, period...

Changes or created /etc/banner for the ftpaccess parser to display an approriate
warnign message on connection.. Similar to /etc/issue...

    This system is for authorized users only. Monitoring may occur

EOF

}

Fix() {

if [ -f /etc/ftpaccess ]; then
    t_echo 2 " Saving /etc/ftpaccess to /etc/ftpaccess.$DATE"
    mv /etc/ftpaccess /etc/ftpaccess.ORIG.${DATE}
    chmod 0400 /etc/ftpaccess.ORIG.${DATE}

  if [ $? -ne 0 ]; then
      t_echo 1 "     Could not rename /etc/ftpaccess - ERROR"
  else
      t_echo 0     " Changing ftpd defaults "
      touch /etc/ftpaccess
	ed /etc/ftpaccess <<- ENDED
	a
	umask 022
	.
	w
	q
	ENDED
  fi

  if [ -z `grep "^banner" /etc/ftpaccess` ]; then
   t_echo 1 "No banner set in ftpaccess - FAILS CHECK"
   echo "banner /etc/ftp-banner" >>/etc/ftpaccess
  else
   echo "banner defined in /etc/ftp-banner - PASSES CHECK" 
  fi
 
  if [ -z `grep "^deny" /etc/ftpaccess | egrep '(passwd|shadow)'` ]; then 
   t_echo 1 "No deny passwd,shadow set in ftpaccess - FAILS CHECK"
   echo "deny passwd shadow" >>/etc/ftpaccess
  else
   echo "deny passwd,shadow defined in /etc/ftpaccess - PASSES CHECK" 
  fi

 chmod 440 /etc/ftpaccess

fi

 if [ -f /etc/ftp-banner ]; then
    t_echo 2 " Saving /etc/ftp-banner to /etc/ftp-banner.ORIG.$DATE"
    mv /etc/ftp-banner /etc/ftp-banner.ORIG.${DATE}
  fi
t_echo 2 " Creating /etc/ftp-banner      "
touch /etc/ftp-banner
ed /etc/ftp-banner <<- ENDED
a
This system is for authorized users only. Monitoring may occur
.
w
q
ENDED
    chmod 644  /etc/ftp-banner 
}

Check() {

if [ -f /etc/ftpaccess ]; then
  grep "^umask" /etc/ftpaccess
     if [ $? -eq 0 ]; then
       t_echo 0 "       /etc/ftpaccess sets umask - PASSES CHECK"
     else
       t_echo 2 "  /etc/ftpacess does not set umask -  FAILS CHECK" 
     fi
fi

if [ -f /etc/ftpaccess ]; then
  grep "^banner" /etc/ftpaccess
    if [ $? -eq 0 ]; then
      t_echo 0 "       /etc/ftpaccess has a BANNER variable - PASSES CHECK"
    else
      t_echo 2 "  /etc/ftpaccess does not set a login BANNER -  FAILS CHECK"
    fi 
fi

if [ ! -f /etc/ftpaccess ]; then
	t_echo 0 "  /etc/ftpaccess does not exist -  FAILS CHECK" 
fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac



# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/ftpaccess /etc/ftp-banner'
