#!/bin/sh
# :
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi


#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro () {

cat << EOF

  Script to disable lpsched in the /etc/rc.d/init.d/lpd file

EOF

}

FixLpsched() {

if [ -f /etc/rc.d/init.d/lpd ] ; then
	cp $FILE /etc/rc.d/init.d/lpd /etc/rc.d/init.d/lpd.$DATE
      for FILE in `ls /etc/rc.d/init.d/lpd`
       do
	if [ -z "`grep -s "daemon lpd" $FILE | grep -v '\#'`" ]; then
 t_echo 2 "         In $FILE lpd is disabled - PASSES CHECK"
	else
 t_echo 0 "        In $FILE lpsched is enabled; REPAIRING "
		ed - $FILE <<- !
			g/daemon lpd/s/daemon lpd/\# daemon lpd/
			w
			q
		!
	fi
   done
fi

}

CheckLpsched() {

if [ -f /etc/rc.d/init.d/lpd ]; then
      for FILE in `ls /etc/rc.d/init.d/lpd`
       do
	if [ -z "`grep -s "daemon lpd" $FILE | grep -v '\#'`" ]; then
 t_echo 2 "         In $FILE lpd is disabled - PASSES CHECK"
	else
 t_echo 0 "        In $FILE lpd is enabled - FAILS CHECK"
	fi
      done
fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	FixLpsched
	;;
	-[Vv]*)
	CheckLpsched
	;;
	*)
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac



# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/rc.d/init.d/lpd'
