:
# automount2.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# lines number 46, 59, and 72 from "grep -v" to "sed" to work with white spaces
# fix recommended by Porter Taylor 
# version 3.0.1  bpowell Mon Jan  4 13:04:08 PST 1999 changed 
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 3.5 bpowell simpler version; just moves S74autofs to s74autofs
# version 4.0.10

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S74autofs'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF
 $MYNAME - This program simply renames S74autofs to s74autofs so that
 automounter does not start at system boot.

EOF

}

Fix() {

if [ -f /etc/rc2.d/S74autofs -o -f /etc/rc3.d/S74autofs ]; then
    for FILE in 'ls /etc/*.d/S??autofs'
    do
    mv $FILE `echo $FILE |tr -s S s`
    done
    t_echo 2 "        Moved $FILE"
else
   t_echo 1 "        System automounter doesn't start at boot - PASSES CHECK" 
 fi

}

Check() {

if [ -f /etc/rc2.d/S74autofs -o -f /etc/rc3.d/S74autofs ]; then
  t_echo 2 "         File /etc/rc2.d/S74autofs exists..."
  AUTOFS=`grep -s "automount" /etc/rc2.d/S74autofs |\
	sed 's/#.*//' | awk '{print $1}'`
 
  if [ -z "${AUTOFS}" ]; then
  t_echo 1 "        No automounter configured - PASSES CHECK"
  else
  t_echo 0 "         Automounter = $AUTOFS      - FAILS CHECK "   
  fi
else
  t_echo 1 "         File /etc/rc2.d/S74autofs doesn't exist - PASSES CHECK "
  exit 1
fi

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
#finis
