:
#
# version 3.6 Wed April 19 08:33:18 PST 2000
# version 4.0.10 Wed May 02 06:04:11 PST 2001

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#
# 2001-04-24 JKR Modify fix to keep original file in same directory, alert if can't find file
#	also modify check to warn if can't find file
#	and not change if syslog line has whitespace before it.

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S74syslog'

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

 
case "`uname -r`" in
5.[89]*) ;;
*)
        t_echo 1 "ERROR - This script is Only supported on Solaris 2.8 and newer"
        exit 1;;
esac
 

Intro() {

cat << EOF

 
Changes the /etc/rc2.d/S74syslog to start syslog with the "-t" flag, This script
should NOT be run on the LOGHOST syslogd system but on every other system that
you don't want black-hats flooding your local syslogd.
Note: LOGHOST should be protected by a firewall mechanism since it is a UDP service.

 From the syslogd man page:


     -t    Disable the syslogd UPD port to turn off logging of
           remote messages.

EOF

}

Fix() {

 if [ -f /etc/rc2.d/S74syslog ]; then
    #JKR grep -i "^\/usr\/sbin\/syslogd\ \-t" /etc/rc2.d/S74syslog
    grep -s "^\	\	\/usr\/sbin\/syslogd\ \-t*" /etc/rc2.d/S74syslog >/dev/null 2>&-
    if [ $? -eq 0 ]; then
       t_echo 2 " /etc/rc2.d/S74syslog is already running -t  - Not Changing"
       exit 1
    else
       if [ -f /etc/rc2.d/S74syslog ]; then
          t_echo 2 " Saving /etc/rc2.d/S74syslog to /etc/rc2.d/s74syslog.ORIG.${DATE}"
          cp /etc/rc2.d/S74syslog /etc/rc2.d/s74syslog.ORIG.${DATE}
	  if [ $? -ne 0 ]; then
             t_echo 1 "     Could not save file to /etc/rc2.d/s72syslog.ORIG.${DATE} - ERROR"
             exit 1
	  else
	     t_echo 2     " Changing syslog startup default "
ed /etc/rc2.d/S74syslog <<- EDEND
g/^\	\	\/usr\/sbin\/syslogd/s//\	\	\/usr\/sbin\/syslogd\ \-t/
.
w
q
EDEND
             t_echo 2 " syslogd startup in /etc/rc2.d/S74syslog changed ... "
          fi
       fi
    fi
 else
    t_echo 1 "     WARNING -- Could not find /etc/rc2.d/S72syslog"
 fi

}

Check() {

        if [ -f /etc/rc2.d/S74syslog ]; then
	grep -s "^\	\	\/usr\/sbin\/syslogd\ \-t*" /etc/rc2.d/S74syslog >/dev/null 2>&-
	if [ $? -eq 1 ]; then
 	 t_echo 0 "       /etc/rc2.d/S74syslog - has the system default . - FAILS CHECK"
	 # exit 1
         else
	t_echo 1 " /etc/rc2.d/S74syslog starts up syslog with the -t option - PASSES CHECK"
	fi
	else
	   t_echo 1	"Warning -- can't find /etc/rc2.d/S74syslog"
         fi
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

