:
# utmp.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 3.6 Wed April 19 08:33:18 PST 2000 utmp removed from solaris 2.7 and newer
# checking OS and not running on 2.7 and newer. Use the utmp2.7.sh for those OS's
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/var/adm/utmp /var/adm/utmpx'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 
#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh
 
case "`uname -r`" in
5.[23456]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is not needed in solaris 2.7 and newer"
        t_echo 1 "please use utmp2.7.sh instead"
        exit 1;;
esac

Intro() {
 
cat << EOF

 $MYNAME : This program Checks utmp, utmpx for world write permissions
 if found resets permissions to 'o-w'


EOF
}
 

Fix() {

for FILE in utmp utmpx
 do
if [ `ls -lL /var/adm/${FILE} |grep -s "^........w"` ]; then
        t_echo 2 "  File utmp writable - Fixing permissions..."
                chmod o-w /var/adm/${FILE}
else
        t_echo 2 "  File ${FILE} permissions set to o-w - Done..."
fi
done

t_echo 2
}


Check() {

for FILE in utmp utmpx
 do
if [ `ls -lL /var/adm/${FILE} |grep -s "^........w"` ]; then
        t_echo 0 "        File utmp writable - FAILS CHECK"
else
        t_echo 1 "        File ${FILE} permissions o-w - PASSES CHECK"
fi
done

t_echo 3
}

action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
