:
# snmpdx-2.6.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.1 Mon Dec 14 10:53:10 PST 1998 change line 60-63 to pass a dot before "$$"
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()
# version 3.0.5 Fri Feb  18 12:42:25 PST 1999 bpowell; fix for solaris 7
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10  2001-04-24 JKR update fix function

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S??snmpdx /etc/rc3.d/S??snmpdx'

. misc_functions.sh

case "`uname -r`" in
5.[678]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF
 
 $MYNAME - Simply moves aside all the snmpdx daemons start up files.
 Snmpdx give out more information than you really want it to. Who needs a
 port scanner if snmpdx is running?

EOF

}

Fix() {

     if [ -f /etc/rc2.d/S??snmpdx -o -f /etc/rc3.d/S??snmpdx ]; then
	for FILE in `ls /etc/rc*.d/S??snmpdx`
	do
	   RF_BASENAME=`basename $FILE`
	   #JKR change S76snmp to s75snmp, disabling it
	   RF_sBASENAME=`echo $RF_BASENAME | sed 's/S/s/1'`
	   RF_DIRNAME=`dirname $FILE`
   	   t_echo 2     " Killing snmpdx daemon "
	   $FILE stop
           t_echo 2 " Saving and disabling $FILE to  $RF_DIRNAME/$RF_sBASENAME.ORIG.$DATE "
           mv  $FILE $RF_DIRNAME/$RF_sBASENAME.ORIG.$DATE
           if [ $? -ne 0 ]; then
              t_echo 1 "     ERROR:Could not rename /etc/$FILE ; exiting"
              exit 1
	   else
	      chmod 0100 $RF_DIRNAME/$RF_sBASENAME.ORIG.$DATE
              t_echo 2 "Done ... "
           fi
	done
     else
	t_echo 1 "  no /etc/rc?.d/S*snmpdx files: PASSES CHECK"
     fi


     #JKR both the previous section and this don't both need to happen, but I guess better safe than sorry
     if [ -f /etc/init.d/init.snmpdx ]; then
        t_echo 2 " Saving /etc/init.d/init.snmpdx to /etc/init.d/init.snmpdx.ORIG.$DATE"
        mv /etc/init.d/init.snmpdx /etc/init.d/init.snmpdx.ORIG.$DATE
        if [ $? -ne 0 ]; then
           t_echo 1 "     ERROR - Could not rename /etc/init.d/init.snmpdx ; exiting"
           exit 1
	else
	   chmod 0100 /etc/init.d/init.snmpdx.ORIG.$DATE
           t_echo 2 "Done ... "
        fi
     else
	t_echo 1 "  Snmpdx doesn't start at boot time: PASSES CHECK"
     fi

}

Check() {

        if [ -f /etc/init.d/init.snmpdx ]; then
         t_echo 0 "   Snmpdx daemon is enabled: FAILS CHECK"
	 exit 1
         else
         t_echo 1 "  Snmpdx doesn't start at boot time: PASSES CHECK" 
         fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

