:
# disable-afbinit.sh
# version 4.0 BETA6 Sat Aug 31 15:26:14 PDT 2002

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 2000, 2001, 2002
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S91afbinit'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro () {

cat << EOF

 $MYNAME -  Script to keep S91afbinit Service Daemon from starting in the 
 /etc/rc2.d/S91afbinit file
 Takes advantage of the fact that /etc/rc?.d files that begin with a small "s"
 don't get started, thus we simply move S91afbinit to s91afbinit

EOF

}

Fix() {

if [ -f /etc/rc2.d/S91afbinit -o -f /etc/rc3.d/S91afbinit ] ; then
      for FILE in `ls /etc/*.d/S91afbinit`
       do
	cp -p $FILE  `echo $FILE | tr -s S s`.ORIG.$DATE 
	t_echo 2 " renaming origional $FILE to `echo $FILE | tr -s S s`.ORIG.$DATE"
	t_echo 2 " renaming $FILE to disable afbinit deamon service"
	mv $FILE `echo $FILE | tr -s S s`
      done
fi

}

Check() {

if [ -f /etc/*.d/S91afbinit ]; then

      for FILE in `ls /etc/*.d/S91afbinit`
       do
	t_echo 0 " afbinit daemon Service is enabled in ${FILE} - FAILS CHECK"
	done
	        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (disable-afbinit.sh -f) The afbinit server daemon should be"
        t_echo 3 "disabled on all Firewalls, and most servers as it is not needed"
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	else
	t_echo 1 " afbinit daemon Service is disabled from starting  - PASSES CHECK"
	fi
}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac


