:
# nuke-nscd.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.1 Fri May  8 12:42:25 PST 1999 bpowell; 
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S76nscd /etc/rc3.d/S73nscd'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro () {

cat << EOF

 $MYNAME -  Script to keep Name Service Cache Daemon from starting in the 
 /etc/rc2.d/S76nscd file
 Takes advantage of the fact that /etc/rc?.d files that begin with a small "s"
 don't get started, thus we simply move S76nscd to s76nscd

EOF

}

Fix() {

if [ -f /etc/rc2.d/S??nscd -o -f /etc/rc3.d/S??nscd ] ; then
      for FILE in `ls /etc/*.d/S??nscd`
       do
	cp -p $FILE  `echo $FILE | tr -s S s`.ORIG.$DATE 
	t_echo 2 " renaming origional $FILE to `echo $FILE | tr -s S s`.ORIG.$DATE"
	t_echo 2 " renaming $FILE to disable nscd service"
	mv $FILE `echo $FILE | tr -s S s`
      done
fi

}

Check() {

if [ -f /etc/*.d/S??nscd ]; then

      for FILE in `ls /etc/*.d/S??nscd`
       do
	t_echo 0 " Name Service Directory Cache is enabled in ${FILE} - FAILS CHECK"
	done
	        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (nuke-nscd.sh -f) The name server cache daemon should be"
        t_echo 3 "disabled on all Firewalls, and most servers as it is easily spoofed, or can be"
        t_echo 3 "flooded from remote. Titan by default disables the nscd."
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	else
	t_echo 1 " Name Service Directory Cache is disabled from starting  - PASSES CHECK"
	fi
}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac


