:
# rmmount.sh
# version 3.1 Mon May 10 08:09:11 PDT 1999
# bpowell
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rmmount.conf'

. misc_functions.sh

case "`uname -r`" in
5.[678]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF

 $MYNAME - Adds the following entries to /etc/rmmount.conf to disable
 mounting suid features as the default:

	mount hsfs -o nosuid
	mount ufs -o nosuid

	Note- This isn't needed if vold is disabled, but doesn't hurt either way.

EOF

}

Fix() {

if [ -f /etc/rmmount.conf ]; then                           
     t_echo 2 " Saving /etc/rmmount.conf to /etc/rmmount.conf.ORIG.$DATE"   
     cp -p /etc/rmmount.conf /etc/rmmount.conf.ORIG.$DATE        
fi                                                      

if [ -f /etc/rmmount.conf ] ; then                            
     t_echo 3 " Adding in the nosuid options now "            
        if grep "^mount hsfs -o nosuid" /etc/rmmount.conf >/dev/null; then  
              t_echo 1 "Rmount has CD filesystems set to disallow suid binaries - PASSES CHECK"
        else                                                  
                echo "mount hsfs -o nosuid" >>/etc/rmmount.conf
        fi                                                    
        if grep "^mount ufs -o nosuid" /etc/rmmount.conf >/dev/null; then   
             t_echo 1 "Rmount has Floppy filesystems set to disallow suid binaries - PASSES CHECK"
        else                                                  
                echo "mount ufs -o nosuid" >>/etc/rmmount.conf
        fi                                                    
fi                            


}

Check() {

	grep "^mount hsfs -o nosuid" /etc/rmmount.conf
	if [ $? -ne 0 ] ; then
	t_echo 0 " Rmount allows mounting of CD filesystems with suid binaries enabled - FAILS CHECK" 
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (rmmount.sh -f) Set system mount defaults to not allow"
        t_echo 3 "suid on removable media preventing someone from inserting a cdrom or floppy with"
        t_echo 3 "a filesystem on it containing a suid root shell."
        t_echo 3 " "
        t_echo 3 "======================================================================== "
	else 
	t_echo 1 "Rmount has CD filesystems set to disallow suid binaries - PASSES CHECK"
	fi
        grep "^mount ufs -o nosuid" /etc/rmmount.conf 
        if [ $? -ne 0 ] ; then 
        t_echo 0 " Rmount allows mounting of Floppy filesystems with suid binaries enabled - FAILS CHECK" 
	else
	t_echo 1 "Rmount has Floppy filesystems set to disallow suid binaries - PASSES CHECK" 

	fi
	   exit 1

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

