:
# lpsched.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0 BETA4 June 16, 2002

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S80lp /etc/rc3.d/S??lp'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro () {

cat << EOF

 $MYNAME -  Script to disable lpsched in the /etc/rc2.d/S??lp file

EOF

}

Fix() {

if [ -f /etc/rc2.d/S??lp -o -f /etc/rc3.d/S??lp ] ; then
      for FILE in `ls /etc/rc*.d/S*lp`
       do
	cp -p $FILE `echo $FILE | tr -s S s`.ORIG.$DATE
	grep -s "/usr/lib/lpsched" $FILE >/dev/null 2>&-
	if [ $? -eq 0 ]; then
 t_echo 2 "        In $FILE lpsched is enabled; REPAIRING "
		ed - $FILE <<- !
			g/\/usr\/lib\/lpsched/s/\/usr\/lib\/lpsched/\/usr\/lib\/lpshut/
			g/\/usr\/lib\/lpsched/s/\/usr\/lib\/lpsched/\/usr\/lib\/lpshut/
			w
			q
		!
	fi
      done
fi

}

Check() {

if [ -f /etc/rc2.d/S??lp -o -f /etc/rc3.d/S??lp ]; then
      for FILE in `ls /etc/rc*.d/S*lp`
       do
	grep -s "/usr/lib/lpsched" $FILE >/dev/null 2>&-
	if [ $? -eq 0 ]; then
 t_echo 0 "        In $FILE lpsched is enabled - FAILS CHECK"
	else
 t_echo 1 "         In $FILE lpsched is disabled - PASSES CHECK"
	fi
      done
fi

if [ ! -f /etc/rc2.d/S??lp -o ! -f /etc/rc3.d/S??lp ]; then
	t_echo 0 " No /etc/rc2.d/S80lp or /etc/rc3.d/S80lp found - PASSES CHECK"
fi


}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac

